-- ftn.ads
-- package Ftn (auxiliary to f2a.pl)
--
-- Ver. |  Date  | History
-- -----+--------+------------------------------------------------------------
--  0.2  97/02/13  initial release (incomplete: builtin functions missing)
--  0.3  97/02/17  no longer use Interfaces.Fortran (due to type incompati-
--                 bility problems), added basic set of intrinsic functions
--  0.4  97/02/20  added missing rename of "**"(float_type,float_type) from
--                 Ada.Numerics.<float_type>_Elementary_Functions
--  0.9  00/01/18  Synced version number with that of f2a.pl.
--                 Removed _Star_ from data type names.
-- ---------------------------------------------------------------------------

with Ada.Strings.Unbounded;
with Ada.Numerics,
     Ada.Numerics.Complex_Types,
     Ada.Numerics.Long_Complex_Types,
     Ada.Numerics.Elementary_Functions,
     Ada.Numerics.Long_Elementary_Functions,
     Ada.Numerics.Long_Long_Elementary_Functions,
     Ada.Numerics.Complex_Elementary_Functions,
     Ada.Numerics.Long_Complex_Elementary_Functions;

package Ftn is

   subtype Logical1 is Boolean;

   type Logical2 is new Boolean;
   for Logical2'size use 16;

   type Logical is new Boolean;
   for Logical'size use 32;

   subtype Integer1 is Short_Short_Integer;

   subtype Integer2 is Short_Integer;

   subtype Real is Float;
   subtype Double is Long_Float;
   subtype Real4 is Float;
   subtype Real8 is Long_Float;
   subtype Real16 is Long_Long_Float;

   package Complex_Types renames Ada.Numerics.Complex_Types;
   subtype Complex is Complex_Types.Complex;
   subtype Complex8 is Complex_Types.Complex;
   package Long_Complex_Types renames Ada.Numerics.Long_Complex_Types;
   subtype Double_Complex is Long_Complex_Types.Complex;
   subtype Complex16 is Long_Complex_Types.Complex;

   subtype Character is Standard.Character;
   subtype Character1  is Character;
   subtype Character2  is String (1 .. 2);
   subtype Character3  is String (1 .. 3);
   subtype Character4  is String (1 .. 4);
   subtype Character5  is String (1 .. 5);
   subtype Character6  is String (1 .. 6);
   subtype Character7  is String (1 .. 7);
   subtype Character8  is String (1 .. 8);
   subtype Character9  is String (1 .. 9);
   subtype Character10 is String (1 .. 10);
   subtype Character11 is String (1 .. 11);
   subtype Character12 is String (1 .. 12);
   subtype Character13 is String (1 .. 13);
   subtype Character14 is String (1 .. 14);
   subtype Character15 is String (1 .. 15);
   subtype Character16 is String (1 .. 16);
   subtype Character17 is String (1 .. 17);
   subtype Character18 is String (1 .. 18);
   subtype Character19 is String (1 .. 19);
   subtype Character20 is String (1 .. 20);
   subtype Character21 is String (1 .. 21);
   subtype Character22 is String (1 .. 22);
   subtype Character23 is String (1 .. 23);
   subtype Character24 is String (1 .. 24);
   subtype Character25 is String (1 .. 25);
   subtype Character26 is String (1 .. 26);
   subtype Character27 is String (1 .. 27);
   subtype Character28 is String (1 .. 28);
   subtype Character29 is String (1 .. 29);
   subtype Character30 is String (1 .. 30);
   subtype Character31 is String (1 .. 31);
   subtype Character32 is String (1 .. 32);
   subtype Character33 is String (1 .. 33);
   subtype Character34 is String (1 .. 34);
   subtype Character35 is String (1 .. 35);
   subtype Character36 is String (1 .. 36);
   subtype Character37 is String (1 .. 37);
   subtype Character38 is String (1 .. 38);
   subtype Character39 is String (1 .. 39);
   subtype Character40 is String (1 .. 40);
   subtype Character41 is String (1 .. 41);
   subtype Character42 is String (1 .. 42);
   subtype Character43 is String (1 .. 43);
   subtype Character44 is String (1 .. 44);
   subtype Character45 is String (1 .. 45);
   subtype Character46 is String (1 .. 46);
   subtype Character47 is String (1 .. 47);
   subtype Character48 is String (1 .. 48);
   subtype Character49 is String (1 .. 49);
   subtype Character50 is String (1 .. 50);
   subtype Character51 is String (1 .. 51);
   subtype Character52 is String (1 .. 52);
   subtype Character53 is String (1 .. 53);
   subtype Character54 is String (1 .. 54);
   subtype Character55 is String (1 .. 55);
   subtype Character56 is String (1 .. 56);
   subtype Character57 is String (1 .. 57);
   subtype Character58 is String (1 .. 58);
   subtype Character59 is String (1 .. 59);
   subtype Character60 is String (1 .. 60);
   subtype Character61 is String (1 .. 61);
   subtype Character62 is String (1 .. 62);
   subtype Character63 is String (1 .. 63);
   subtype Character64 is String (1 .. 64);
   subtype Character65 is String (1 .. 65);
   subtype Character66 is String (1 .. 66);
   subtype Character67 is String (1 .. 67);
   subtype Character68 is String (1 .. 68);
   subtype Character69 is String (1 .. 69);
   subtype Character70 is String (1 .. 70);
   subtype Character71 is String (1 .. 71);
   subtype Character72 is String (1 .. 72);
   subtype Character73 is String (1 .. 73);
   subtype Character74 is String (1 .. 74);
   subtype Character75 is String (1 .. 75);
   subtype Character76 is String (1 .. 76);
   subtype Character77 is String (1 .. 77);
   subtype Character78 is String (1 .. 78);
   subtype Character79 is String (1 .. 79);
   subtype Character80 is String (1 .. 80);
   subtype Character81 is String (1 .. 81);
   subtype Character82 is String (1 .. 82);
   subtype Character83 is String (1 .. 83);
   subtype Character84 is String (1 .. 84);
   subtype Character85 is String (1 .. 85);
   subtype Character86 is String (1 .. 86);
   subtype Character87 is String (1 .. 87);
   subtype Character88 is String (1 .. 88);
   subtype Character89 is String (1 .. 89);
   subtype Character90 is String (1 .. 90);
   subtype Character91 is String (1 .. 91);
   subtype Character92 is String (1 .. 92);
   subtype Character93 is String (1 .. 93);
   subtype Character94 is String (1 .. 94);
   subtype Character95 is String (1 .. 95);
   subtype Character96 is String (1 .. 96);
   subtype Character97 is String (1 .. 97);
   subtype Character98 is String (1 .. 98);
   subtype Character99 is String (1 .. 99);
   subtype Character100 is String (1 .. 100);
   subtype Character110 is String (1 .. 110);
   subtype Character120 is String (1 .. 120);
   subtype Character127 is String (1 .. 127);
   subtype Character128 is String (1 .. 128);
   subtype Character129 is String (1 .. 129);
   subtype Character130 is String (1 .. 130);
   subtype Character131 is String (1 .. 131);
   subtype Character132 is String (1 .. 132);
   subtype Character140 is String (1 .. 140);
   subtype Character150 is String (1 .. 150);
   subtype Character160 is String (1 .. 160);
   subtype Character180 is String (1 .. 180);
   subtype Character200 is String (1 .. 200);
   subtype Character255 is String (1 .. 255);
   subtype Character256 is String (1 .. 256);

   type Character_Star is new Ada.Strings.Unbounded.Unbounded_String;
   function "+" (S : String) return Character_Star renames To_Unbounded_String;


   -- Array types

   -- one-dimensional
   type Logical1_Array  is array (Integer range <>) of Logical1;
   type Logical2_Array  is array (Integer range <>) of Logical2;
   type Logical_Array   is array (Integer range <>) of Logical;
   type Integer1_Array  is array (Integer range <>) of Integer1;
   type Integer2_Array  is array (Integer range <>) of Integer2;
   type Integer_Array   is array (Integer range <>) of Integer;
   type Real_Array      is array (Integer range <>) of Real;
   type Double_Array    is array (Integer range <>) of Double;
   type Complex_Array   is array (Integer range <>) of Complex;
   type Complex16_Array is array (Integer range <>) of Complex16;

   -- two-dimensional
   type Logical1_Array_2D is array
     (Integer range <>, Integer range <>) of Logical1;
      pragma Convention (Fortran, Logical1_Array_2D);
   type Logical2_Array_2D is array
     (Integer range <>, Integer range <>) of Logical2;
      pragma Convention (Fortran, Logical2_Array_2D);
   type Logical_Array_2D is array
     (Integer range <>, Integer range <>) of Logical;
      pragma Convention (Fortran, Logical_Array_2D);
   type Integer1_Array_2D is array
     (Integer range <>, Integer range <>) of Integer1;
      pragma Convention (Fortran, Integer1_Array_2D);
   type Integer2_Array_2D is array
     (Integer range <>, Integer range <>) of Integer2;
      pragma Convention (Fortran, Integer2_Array_2D);
   type Integer_Array_2D is array
     (Integer range <>, Integer range <>) of Integer;
      pragma Convention (Fortran, Integer_Array_2D);
   type Real_Array_2D is array
     (Integer range <>, Integer range <>) of Real;
      pragma Convention (Fortran, Real_Array_2D);
   type Double_Array_2D is array
     (Integer range <>, Integer range <>) of Double;
      pragma Convention (Fortran, Double_Array_2D);
   type Complex_Array_2D is array
     (Integer range <>, Integer range <>) of Complex;
      pragma Convention (Fortran, Complex_Array_2D);
   type Complex16_Array_2D is array
     (Integer range <>, Integer range <>) of Complex16;
      pragma Convention (Fortran, Complex16_Array_2D);

   -- three-dimensional
   type Logical1_Array_3D is array
     (Integer range <>, Integer range <>, Integer range <>) of Logical1;
      pragma Convention (Fortran, Logical1_Array_3D);
   type Logical2_Array_3D is array
     (Integer range <>, Integer range <>, Integer range <>) of Logical2;
      pragma Convention (Fortran, Logical2_Array_3D);
   type Logical_Array_3D is array
     (Integer range <>, Integer range <>, Integer range <>) of Logical;
      pragma Convention (Fortran, Logical_Array_3D);
   type Integer1_Array_3D is array
     (Integer range <>, Integer range <>, Integer range <>) of Integer1;
      pragma Convention (Fortran, Integer1_Array_3D);
   type Integer2_Array_3D is array
     (Integer range <>, Integer range <>, Integer range <>) of Integer2;
      pragma Convention (Fortran, Integer2_Array_3D);
   type Integer_Array_3D is array
     (Integer range <>, Integer range <>, Integer range <>) of Integer;
      pragma Convention (Fortran, Integer_Array_3D);
   type Real_Array_3D is array
     (Integer range <>, Integer range <>, Integer range <>) of Real;
      pragma Convention (Fortran, Real_Array_3D);
   type Double_Array_3D is array
     (Integer range <>, Integer range <>, Integer range <>) of Double;
      pragma Convention (Fortran, Double_Array_3D);
   type Complex_Array_3D is array
     (Integer range <>, Integer range <>, Integer range <>) of Complex;
      pragma Convention (Fortran, Complex_Array_3D);
   type Complex16_Array_3D is array
     (Integer range <>, Integer range <>, Integer range <>) of Complex16;
      pragma Convention (Fortran, Complex16_Array_3D);

   -- four and higher dimensions TBD


   -- additional operators

   function "**" (Left, Right : Real) return Real
                 renames Ada.Numerics.Elementary_Functions."**";
   function "**" (Left, Right : Double) return Double
                 renames Ada.Numerics.Long_Elementary_Functions."**";
   function "**" (Left, Right : Real16) return Real16
                 renames Ada.Numerics.Long_Long_Elementary_Functions."**";


   -- DEC Fortran intrinsic functions

   function Sqrt   (X : Real) return Real
                   renames Ada.Numerics.Elementary_Functions.Sqrt;
   function Sqrt   (X : Double) return Double
                   renames Ada.Numerics.Long_Elementary_Functions.Sqrt;
   function Sqrt   (X : Real16) return Real16
                   renames Ada.Numerics.Long_Long_Elementary_Functions.Sqrt;
   function Sqrt   (X : Complex) return Complex
                   renames Ada.Numerics.Complex_Elementary_Functions.Sqrt;
   function Sqrt   (X : Double_Complex) return Double_Complex
                   renames Ada.Numerics.Long_Complex_Elementary_Functions.Sqrt;
   function DSqrt  (X : Double) return Double
                   renames Sqrt;
   function QSqrt  (X : Real16) return Real16
                   renames Sqrt;
   function CSqrt  (X : Complex) return Complex
                   renames Sqrt;
   function CDSqrt (X : Double_Complex) return Double_Complex
                   renames Sqrt;

   function Log    (X : Real) return Real
                   renames Ada.Numerics.Elementary_Functions.Log;
   function Log    (X : Double) return Double
                   renames Ada.Numerics.Long_Elementary_Functions.Log;
   function Log    (X : Real16) return Real16
                   renames Ada.Numerics.Long_Long_Elementary_Functions.Log;
   function Log    (X : Complex) return Complex
                   renames Ada.Numerics.Complex_Elementary_Functions.Log;
   function Log    (X : Double_Complex) return Double_Complex
                   renames Ada.Numerics.Long_Complex_Elementary_Functions.Log;
   function ALog   (X : Real) return Real
                   renames Log;
   function DLog   (X : Double) return Double
                   renames Log;
   function QLog   (X : Real16) return Real16
                   renames Log;
   function CLog   (X : Complex) return Complex
                   renames Log;
   function CDLog  (X : Double_Complex) return Double_Complex
                   renames Log;

   function Log10  (X : Real) return Real;
      pragma Inline (Log10);
   function Log10  (X : Double) return Double;
      pragma Inline (Log10);
   function Log10  (X : Real16) return Real16;
      pragma Inline (Log10);
   function ALog10 (X : Real) return Real
                   renames Log10;
   function DLog10 (X : Double) return Double
                   renames Log10;
   function QLog10 (X : Real16) return Real16
                   renames Log10;

   function Exp    (X : Real) return Real
                   renames Ada.Numerics.Elementary_Functions.Exp;
   function Exp    (X : Double) return Double
                   renames Ada.Numerics.Long_Elementary_Functions.Exp;
   function Exp    (X : Real16) return Real16
                   renames Ada.Numerics.Long_Long_Elementary_Functions.Exp;
   function Exp    (X : Complex) return Complex
                   renames Ada.Numerics.Complex_Elementary_Functions.Exp;
   function Exp    (X : Double_Complex) return Double_Complex
                   renames Ada.Numerics.Long_Complex_Elementary_Functions.Exp;
   function DExp   (X : Double) return Double
                   renames Exp;
   function QExp   (X : Real16) return Real16
                   renames Exp;
   function CExp   (X : Complex) return Complex
                   renames Exp;
   function CDExp  (X : Double_Complex) return Double_Complex
                   renames Exp;

   function Sin    (X : Real) return Real
                   renames Ada.Numerics.Elementary_Functions.Sin;
   function Sin    (X : Double) return Double
                   renames Ada.Numerics.Long_Elementary_Functions.Sin;
   function Sin    (X : Real16) return Real16
                   renames Ada.Numerics.Long_Long_Elementary_Functions.Sin;
   function Sin    (X : Complex) return Complex
                   renames Ada.Numerics.Complex_Elementary_Functions.Sin;
   function Sin    (X : Double_Complex) return Double_Complex
                   renames Ada.Numerics.Long_Complex_Elementary_Functions.Sin;
   function DSin   (X : Double) return Double
                   renames Sin;
   function QSin   (X : Real16) return Real16
                   renames Sin;
   function CSin   (X : Complex) return Complex
                   renames Sin;
   function CDSin  (X : Double_Complex) return Double_Complex
                   renames Sin;

   function SinD   (X : Real) return Real;
      pragma Inline (SinD);
   function SinD   (X : Double) return Double;
      pragma Inline (SinD);
   function SinD   (X : Real16) return Real16;
      pragma Inline (SinD);
   function DSinD  (X : Double) return Double
                   renames SinD;
   function QSinD  (X : Real16) return Real16
                   renames SinD;

   function Cos    (X : Real) return Real
                   renames Ada.Numerics.Elementary_Functions.Cos;
   function Cos    (X : Double) return Double
                   renames Ada.Numerics.Long_Elementary_Functions.Cos;
   function Cos    (X : Real16) return Real16
                   renames Ada.Numerics.Long_Long_Elementary_Functions.Cos;
   function Cos    (X : Complex) return Complex
                   renames Ada.Numerics.Complex_Elementary_Functions.Cos;
   function Cos    (X : Double_Complex) return Double_Complex
                   renames Ada.Numerics.Long_Complex_Elementary_Functions.Cos;
   function DCos   (X : Double) return Double
                   renames Cos;
   function QCos   (X : Real16) return Real16
                   renames Cos;
   function CCos   (X : Complex) return Complex
                   renames Cos;
   function CDCos  (X : Double_Complex) return Double_Complex
                   renames Cos;

   function CosD   (X : Real) return Real;
      pragma Inline (CosD);
   function CosD   (X : Double) return Double;
      pragma Inline (CosD);
   function CosD   (X : Real16) return Real16;
      pragma Inline (CosD);
   function DCosD  (X : Double) return Double
                   renames CosD;
   function QCosD  (X : Real16) return Real16
                   renames CosD;

   function Tan    (X : Real) return Real
                   renames Ada.Numerics.Elementary_Functions.Tan;
   function Tan    (X : Double) return Double
                   renames Ada.Numerics.Long_Elementary_Functions.Tan;
   function Tan    (X : Real16) return Real16
                   renames Ada.Numerics.Long_Long_Elementary_Functions.Tan;
   function DTan   (X : Double) return Double
                   renames Tan;
   function QTan   (X : Real16) return Real16
                   renames Tan;

   function TanD   (X : Real) return Real;
      pragma Inline (TanD);
   function TanD   (X : Double) return Double;
      pragma Inline (TanD);
   function TanD   (X : Real16) return Real16;
      pragma Inline (TanD);
   function DTanD  (X : Double) return Double
                   renames TanD;
   function QTanD  (X : Real16) return Real16
                   renames TanD;

   function Asin   (X : Real) return Real
                   renames Ada.Numerics.Elementary_Functions.Arcsin;
   function Asin   (X : Double) return Double
                   renames Ada.Numerics.Long_Elementary_Functions.Arcsin;
   function Asin   (X : Real16) return Real16
                   renames Ada.Numerics.Long_Long_Elementary_Functions.Arcsin;
   function DAsin  (X : Double) return Double
                   renames Asin;
   function QAsin  (X : Real16) return Real16
                   renames Asin;

   function AsinD  (X : Real) return Real;
      pragma Inline (AsinD);
   function AsinD  (X : Double) return Double;
      pragma Inline (AsinD);
   function AsinD  (X : Real16) return Real16;
      pragma Inline (AsinD);
   function DAsinD (X : Double) return Double
                   renames AsinD;
   function QAsinD (X : Real16) return Real16
                   renames AsinD;

   function Acos   (X : Real) return Real
                   renames Ada.Numerics.Elementary_Functions.Arccos;
   function Acos   (X : Double) return Double
                   renames Ada.Numerics.Long_Elementary_Functions.Arccos;
   function Acos   (X : Real16) return Real16
                   renames Ada.Numerics.Long_Long_Elementary_Functions.Arccos;
   function DAcos  (X : Double) return Double
                   renames Acos;
   function QAcos  (X : Real16) return Real16
                   renames Acos;

   function AcosD  (X : Real) return Real;
      pragma Inline (AcosD);
   function AcosD  (X : Double) return Double;
      pragma Inline (AcosD);
   function AcosD  (X : Real16) return Real16;
      pragma Inline (AcosD);
   function DAcosD (X : Double) return Double
                   renames AcosD;
   function QAcosD (X : Real16) return Real16
                   renames AcosD;

   function Atan   (X : Real) return Real;
      pragma Inline (Atan);
   function Atan   (X : Double) return Double;
      pragma Inline (Atan);
   function Atan   (X : Real16) return Real16;
      pragma Inline (Atan);
   function DAtan  (X : Double) return Double
                   renames Atan;
   function QAtan  (X : Real16) return Real16
                   renames Atan;

   function AtanD  (X : Real) return Real;
      pragma Inline (AtanD);
   function AtanD  (X : Double) return Double;
      pragma Inline (AtanD);
   function AtanD  (X : Real16) return Real16;
      pragma Inline (AtanD);
   function DAtanD (X : Double) return Double
                   renames AtanD;
   function QAtanD (X : Real16) return Real16
                   renames AtanD;

   function Atan2  (Y, X : Real) return Real;
      pragma Inline (Atan2);
   function Atan2  (Y, X : Double) return Double;
      pragma Inline (Atan2);
   function Atan2  (Y, X : Real16) return Real16;
      pragma Inline (Atan2);
   function DAtan2 (Y, X : Double) return Double
                   renames Atan2;
   function QAtan2 (Y, X : Real16) return Real16
                   renames Atan2;

   function Atan2D (Y, X : Real) return Real;
      pragma Inline (Atan2D);
   function Atan2D (Y, X : Double) return Double;
      pragma Inline (Atan2D);
   function Atan2D (Y, X : Real16) return Real16;
      pragma Inline (Atan2D);
   function DAtan2D (Y, X : Double) return Double
                    renames Atan2D;
   function QAtan2D (Y, X : Real16) return Real16
                    renames Atan2D;

   function Sinh   (X : Real) return Real
                   renames Ada.Numerics.Elementary_Functions.Sinh;
   function Sinh   (X : Double) return Double
                   renames Ada.Numerics.Long_Elementary_Functions.Sinh;
   function Sinh   (X : Real16) return Real16
                   renames Ada.Numerics.Long_Long_Elementary_Functions.Sinh;
   function DSinh  (X : Double) return Double
                   renames Sinh;
   function QSinh  (X : Real16) return Real16
                   renames Sinh;

   function Cosh   (X : Real) return Real
                   renames Ada.Numerics.Elementary_Functions.Cosh;
   function Cosh   (X : Double) return Double
                   renames Ada.Numerics.Long_Elementary_Functions.Cosh;
   function Cosh   (X : Real16) return Real16
                   renames Ada.Numerics.Long_Long_Elementary_Functions.Cosh;
   function DCosh  (X : Double) return Double
                   renames Cosh;
   function QCosh  (X : Real16) return Real16
                   renames Cosh;

   function Tanh   (X : Real) return Real
                   renames Ada.Numerics.Elementary_Functions.Tanh;
   function Tanh   (X : Double) return Double
                   renames Ada.Numerics.Long_Elementary_Functions.Tanh;
   function Tanh   (X : Real16) return Real16
                   renames Ada.Numerics.Long_Long_Elementary_Functions.Tanh;
   function DTanh  (X : Double) return Double
                   renames Tanh;
   function QTanh  (X : Real16) return Real16
                   renames Tanh;

   function IIAbs  (X : Integer2) return Integer2
                   renames "abs";
   function JIAbs  (X : Integer) return Integer
                   renames "abs";
   function DAbs   (X : Double) return Double
                   renames "abs";
   function QAbs   (X : Real16) return Real16
                   renames "abs";
   function CAbs   (X : Complex) return Real
                   renames Complex_Types."abs";
   function CDAbs  (X : Double_Complex) return Double
                   renames Long_Complex_Types."abs";

   function Int    (X : Real) return Integer2;
      pragma Inline (Int);
   function Int    (X : Real) return Integer;
      pragma Inline (Int);
   function Int    (X : Double) return Integer2;
      pragma Inline (Int);
   function Int    (X : Double) return Integer;
      pragma Inline (Int);
   function Int    (X : Real16) return Integer2;
      pragma Inline (Int);
   function Int    (X : Real16) return Integer;
      pragma Inline (Int);
   function IDInt  (X : Double) return Integer2
                   renames Int;
   function IDInt  (X : Double) return Integer
                   renames Int;
   function IQInt  (X : Real16) return Integer2
                   renames Int;
   function IQInt  (X : Real16) return Integer
                   renames Int;
   function IInt   (X : Real) return Integer2
                   renames Int;
   function JInt   (X : Real) return Integer
                   renames Int;
   function IIDInt (X : Double) return Integer2
                   renames Int;
   function JIDInt (X : Double) return Integer
                   renames Int;
   function IIQInt (X : Real16) return Integer2
                   renames Int;
   function JIQInt (X : Real16) return Integer
                   renames Int;

   function Aint   (X : Real) return Real;
      pragma Inline (Aint);
   function Aint   (X : Double) return Double;
      pragma Inline (Aint);
   function Aint   (X : Real16) return Real16;
      pragma Inline (Aint);
   function Dint   (X : Double) return Double
                   renames Aint;
   function Qint   (X : Real16) return Real16
                   renames Aint;

   function Nint   (X : Real) return Integer2;
      pragma Inline (Nint);
   function Nint   (X : Real) return Integer;
      pragma Inline (Nint);
   function Nint   (X : Double) return Integer2;
      pragma Inline (Nint);
   function Nint   (X : Double) return Integer;
      pragma Inline (Nint);
   function Nint   (X : Real16) return Integer2;
      pragma Inline (Nint);
   function Nint   (X : Real16) return Integer;
      pragma Inline (Nint);
   function IDNint (X : Double) return Integer2
                   renames Nint;
   function IDNint (X : Double) return Integer
                   renames Nint;
   function IQNint (X : Real16) return Integer2
                   renames Nint;
   function IQNint (X : Real16) return Integer
                   renames Nint;
   function INint  (X : Real) return Integer2
                   renames Nint;
   function JNint  (X : Real) return Integer
                   renames Nint;
   function IIDNnt (X : Double) return Integer2
                   renames Nint;
   function JIDNnt (X : Double) return Integer
                   renames Nint;
   function IIQNnt (X : Real16) return Integer2
                   renames Nint;
   function JIQNnt (X : Real16) return Integer
                   renames Nint;
   function ANint  (X : Real) return Real;
      pragma Inline (ANint);
   function DNint  (X : Double) return Double;
      pragma Inline (DNint);
   function QNint  (X : Real16) return Real16;
      pragma Inline (QNint);

   subtype Sngl is Real;               --  for type cast function SNGL()
   subtype Dble is Double;   --  for type cast function DBLE()
   subtype Qext is Real16;       --  for type cast function QEXT()

   function Ifix   (X : Real) return Integer2;
      pragma Inline (Ifix);
   function Ifix   (X : Real) return Integer;
      pragma Inline (Ifix);

   -- Type cast function FLOAT() fortunately conincides with the name of
   -- the Ada type of which type REAL is a subtype

   subtype Qfloat is Real16;     --  for type cast function QFLOAT()

   -- the Complex stuff: To Be Done


   function Max (A1 : Integer2;
                 A2 : Integer2;
                 A3 : Integer2 := Integer2'first;
                 A4 : Integer2 := Integer2'first;
                 A5 : Integer2 := Integer2'first;
                 A6 : Integer2 := Integer2'first;
                 A7 : Integer2 := Integer2'first;
                 A8 : Integer2 := Integer2'first;
                 A9 : Integer2 := Integer2'first;
                 A10 : Integer2 := Integer2'first)
            return Integer2;

   function Max (A1 : Integer;
                 A2 : Integer;
                 A3 : Integer := Integer'first;
                 A4 : Integer := Integer'first;
                 A5 : Integer := Integer'first;
                 A6 : Integer := Integer'first;
                 A7 : Integer := Integer'first;
                 A8 : Integer := Integer'first;
                 A9 : Integer := Integer'first;
                 A10 : Integer := Integer'first)
            return Integer;

   function Max (A1 : Real;
                 A2 : Real;
                 A3 : Real := Real'first;
                 A4 : Real := Real'first;
                 A5 : Real := Real'first;
                 A6 : Real := Real'first;
                 A7 : Real := Real'first;
                 A8 : Real := Real'first;
                 A9 : Real := Real'first;
                 A10 : Real := Real'first)
            return Real;

   function Max (A1 : Double;
                 A2 : Double;
                 A3 : Double := Double'first;
                 A4 : Double := Double'first;
                 A5 : Double := Double'first;
                 A6 : Double := Double'first;
                 A7 : Double := Double'first;
                 A8 : Double := Double'first;
                 A9 : Double := Double'first;
                 A10 : Double := Double'first)
            return Double;

   function Max (A1 : Real16;
                 A2 : Real16;
                 A3 : Real16 := Real16'first;
                 A4 : Real16 := Real16'first;
                 A5 : Real16 := Real16'first;
                 A6 : Real16 := Real16'first;
                 A7 : Real16 := Real16'first;
                 A8 : Real16 := Real16'first;
                 A9 : Real16 := Real16'first;
                 A10 : Real16 := Real16'first)
            return Real16;


   function Min (A1 : Integer2;
                 A2 : Integer2;
                 A3 : Integer2 := Integer2'first;
                 A4 : Integer2 := Integer2'first;
                 A5 : Integer2 := Integer2'first;
                 A6 : Integer2 := Integer2'first;
                 A7 : Integer2 := Integer2'first;
                 A8 : Integer2 := Integer2'first;
                 A9 : Integer2 := Integer2'first;
                 A10 : Integer2 := Integer2'first)
            return Integer2;

   function Min (A1 : Integer;
                 A2 : Integer;
                 A3 : Integer := Integer'first;
                 A4 : Integer := Integer'first;
                 A5 : Integer := Integer'first;
                 A6 : Integer := Integer'first;
                 A7 : Integer := Integer'first;
                 A8 : Integer := Integer'first;
                 A9 : Integer := Integer'first;
                 A10 : Integer := Integer'first)
            return Integer;

   function Min (A1 : Real;
                 A2 : Real;
                 A3 : Real := Real'first;
                 A4 : Real := Real'first;
                 A5 : Real := Real'first;
                 A6 : Real := Real'first;
                 A7 : Real := Real'first;
                 A8 : Real := Real'first;
                 A9 : Real := Real'first;
                 A10 : Real := Real'first)
            return Real;

   function Min (A1 : Double;
                 A2 : Double;
                 A3 : Double := Double'first;
                 A4 : Double := Double'first;
                 A5 : Double := Double'first;
                 A6 : Double := Double'first;
                 A7 : Double := Double'first;
                 A8 : Double := Double'first;
                 A9 : Double := Double'first;
                 A10 : Double := Double'first)
            return Double;

   function Min (A1 : Real16;
                 A2 : Real16;
                 A3 : Real16 := Real16'first;
                 A4 : Real16 := Real16'first;
                 A5 : Real16 := Real16'first;
                 A6 : Real16 := Real16'first;
                 A7 : Real16 := Real16'first;
                 A8 : Real16 := Real16'first;
                 A9 : Real16 := Real16'first;
                 A10 : Real16 := Real16'first)
            return Real16;


   function Dim    (A1, A2 : Integer2) return Integer2;
      pragma Inline (Dim);
   function Dim    (A1, A2 : Integer) return Integer;
      pragma Inline (Dim);
   function Dim    (A1, A2 : Real) return Real;
      pragma Inline (Dim);
   function Dim    (A1, A2 : Double) return Double;
      pragma Inline (Dim);
   function Dim    (A1, A2 : Real16) return Real16;
      pragma Inline (Dim);

   -- MOD() : To Be Done

   function Sign   (A1, A2 : Integer2) return Integer2;
      pragma Inline (Sign);
   function Sign   (A1, A2 : Integer) return Integer;
      pragma Inline (Sign);
   function Sign   (A1, A2 : Real) return Real;
      pragma Inline (Sign);
   function Sign   (A1, A2 : Double) return Double;
      pragma Inline (Sign);
   function Sign   (A1, A2 : Real16) return Real16;
      pragma Inline (Sign);

   function Ran (Seed : Integer) return Real;
   function Ran (Seed : Integer) return Double;


end Ftn;
